

import g4p_controls.*;       //importo la libreria degli elementi standard di una GUI
import processing.serial.*;  //importo la libreria seriale

int rosso, verde, blu;
int valoreSliderFence,valoreSliderMill;
String   porta;
int valPot= 0;
int Fence=0;
int Mill=0;
Serial arduinoPort;
GCustomSlider sdrFence, sdrMill;                                // create sliders "Fence" and "Mill"
GLabel label1, label2,lblFile, lblFile2, Porte;                 //creo le label
GButton btnFenceZero, btnMillZero, btnAngleZero, btnOptions;    //creo i bottoni
GDropList sceltaPorta;                                          //creo una lista per selezionare la porta corretta
GButton  btnConnetti;
int degree = 0;

void setup() {
  size(620, 280);  
  frame.setTitle("Rotala");    // Window Title
  //=============================================================
  // Fence Slider Builder
  sdrFence = new GCustomSlider(this, 20, 30, 580, 50, null);
  sdrFence.setShowDecor(false, false, true, true);
  sdrFence.setNbrTicks(5);
  sdrFence.setLimits(60, -50, 500);
  valoreSliderFence=0;

  // Mill Slider Builder
  sdrMill = new GCustomSlider(this, 20, 100, 580, 50, null);
  sdrMill.setShowDecor(false, false, true, true);
  sdrMill.setNbrTicks(5);
  sdrMill.setLimits(0, -20, 100);
  valoreSliderMill=0;
  
  //=============================================================
  //label
  label1 = new GLabel(this, 250, 0, 110, 50);
  label1.setText("Fence Distance");
  label1.setTextBold();  
  
  label2 = new GLabel(this, 250, 70, 110, 50);
  label2.setText("Mill Height");
  label2.setTextBold(); 
  
  lblFile2 = new GLabel(this, 50, 130, 110, 50); 
  lblFile2.setText("Fence Distance");
  lblFile2.setTextBold(); 
  
  lblFile = new GLabel(this, 200, 130, 110, 50); 
  lblFile.setText("Mill Height");
  lblFile.setTextBold(); 
  
  lblFile = new GLabel(this, 350, 130, 110, 50);   // func, Margin Left,Margin Top, Widht, Height.
  lblFile.setText("Inclination");
  lblFile.setTextBold(); 

  Porte = new GLabel(this, 500, 130, 110, 50); 
  Porte.setText("Port Selection");
  Porte.setTextBold();   
  //=============================================================
  //bottoni
  btnFenceZero = new GButton(this, 50, 220, 80, 40, "Fence Zero");
  btnFenceZero.setTextBold();
  btnFenceZero.setLocalColorScheme(5);
  
  btnMillZero  = new GButton(this, 190, 220, 80, 40, "Mill Zero");
  btnMillZero.setTextBold();
  btnMillZero.setLocalColorScheme(5);

  btnAngleZero = new GButton(this, 360, 220, 80, 40, "Angle Zero");
  btnAngleZero.setTextBold();
  btnAngleZero.setLocalColorScheme(5);
  
  btnOptions   = new GButton(this, 490, 220, 80, 40, "Options");
  btnOptions.setTextBold();
  btnOptions.setLocalColorScheme(5);
  
  btnConnetti = new GButton(this, 515, 187, 70, 15, "Connect");  // Margin Left px, Margin Top px, Widht px, Heigt px,
  btnConnetti.setTextBold();
  btnConnetti.setLocalColorScheme(7);  
  
  //=============================================================
  //porta seriale
  
  sceltaPorta = new GDropList(this,515,170,80,50,3);  // Create window menu
  sceltaPorta.setItems(Serial.list(),0);              // lista delle porte, è necessario selezionare quella di Arduino
  porta = sceltaPorta.getSelectedText();              // 
  arduinoPort = new Serial(this, porta, 9600);        //assegno la porta selezionane a quella di connessione
}

void draw() {
  //colore del background
  background(68, 111, 216);
  //=============================================================
  //Define a  Box to Display Selected Measure (Fence Distance)
  strokeWeight(4);            // Border px
  stroke(104, 104, 255);      // Border Color RGB
  fill(255, 255, 255);        // Box background Color RGB
  rect(50,165,110,40,7);      // Margin Left px, Margin Top px, Widht px, Heigt px, 
  textSize(32);               // !!!
  fill(10, 102, 153);         // Text Color
  text(Fence, 95, 197);      // Function to Display, Margin left, Margin Top.
  Fence = sdrFence.getValueI();  // Define "degree" function: copy the Slider1 value  
  
  
  //Define a  Box to Display Selected Measure (Mill Height)
  strokeWeight(4);           // Border px
  stroke(104, 104, 255);     // Border Color RGB
  fill(255, 255, 255);       // Box background Color RGB
  rect(200,165,110,40,7);    // Margin Left px, Margin Top px, Widht px, Heigt px, 
  textSize(32);              // !!!
  fill(10, 102, 153);        // Text Color
  text(Mill, 245, 197);    // Function to Display, Margin left, Margin Top.
  Mill = sdrMill.getValueI(); // Define "degree" function: copy the Slider1 value
    
  //Define a  Box to Display Selected Measure (Angle)
  strokeWeight(4);           // Border px
  stroke(104, 104, 255);     // Border Color RGB
  fill(255, 255, 155);       // Box background Color RGB
  rect(350,165,110,40,7);    // Margin Left px, Margin Top px, Widht px, Heigt px, 

  
 if ((valoreSliderFence == rosso) && (valoreSliderMill == verde)){}
else{
//Send Values
  setZero();
  arduinoPort.write('V');
  arduinoPort.write(verde);
valoreSliderMill=verde;  

  arduinoPort.write('R');  
  arduinoPort.write(rosso);
valoreSliderFence=rosso;

} 
  
if (arduinoPort.available() > 0){ // if Arduino send data
  degree = arduinoPort.read(); }  // read the pot value and store in "degrree"
  textSize(32);
  fill(10, 102, 153);        // Text Color
  text(degree, 395, 197);    // Function to Display, Margin left, Margin Top.

}


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
public void handleButtonEvents(GButton button, GEvent event) {     //azione bottoni

  if (button == btnConnetti){
    porta = sceltaPorta.getSelectedText();
    arduinoPort = new Serial(this, porta, 9600);  println(porta);}
    

  else if (button == btnFenceZero){
    arduinoPort.write('B');
    arduinoPort.write(255);
    arduinoPort.write('R');
    arduinoPort.write(0);
    arduinoPort.write('V');
    arduinoPort.write(0);}
  else if (button == btnMillZero){
    arduinoPort.write('V');
    arduinoPort.write(255);
    arduinoPort.write('R');
    arduinoPort.write(0);
    arduinoPort.write('B');
    arduinoPort.write(0);}  
  else if (button == btnAngleZero){
    arduinoPort.write('R');
    arduinoPort.write(255);
    arduinoPort.write('B');
    arduinoPort.write(0);
    arduinoPort.write('V');
    arduinoPort.write(0);}    

}
    
void setZero(){
  arduinoPort.write('V');
  arduinoPort.write(0);
  arduinoPort.write('R');  
  arduinoPort.write(0);
  arduinoPort.write('B');
  arduinoPort.write(0);
}
  
